QCA::DHPrivateKey Class Reference
QCA user API

`#include <QtCrypto>`

Collaboration diagram for QCA::DHPrivateKey:
[legend]

## Public Member Functions

| DHPrivateKey ()
| DHPrivateKey (const DLGroup &domain, const BigInteger &y, const BigInteger &x, const QString &provider=QString())
DLGroup | domain () const
BigInteger | x () const
BigInteger | y () const
Public Member Functions inherited from QCA::PrivateKey
bool | canDecrypt () const
bool | canEncrypt () const
bool | canSign () const
bool | decrypt (const SecureArray &in, SecureArray *out, EncryptionAlgorithm alg)
SymmetricKey | deriveKey (const PublicKey &theirs)
SecureArray | encrypt (const SecureArray &a, EncryptionAlgorithm alg)
int | maximumEncryptSize (EncryptionAlgorithm alg) const
PrivateKey & | operator= (const PrivateKey &from)
| PrivateKey ()
| PrivateKey (const PrivateKey &from)
| PrivateKey (const QString &fileName, const SecureArray &passphrase=SecureArray())
QByteArray | signature ()
QByteArray | signMessage (const MemoryRegion &a, SignatureAlgorithm alg, SignatureFormat format=DefaultFormat)
void | startSign (SignatureAlgorithm alg, SignatureFormat format=DefaultFormat)
SecureArray | toDER (const SecureArray &passphrase=SecureArray(), PBEAlgorithm pbe=PBEDefault) const
DHPrivateKey | toDH () const
DSAPrivateKey | toDSA () const
QString | toPEM (const SecureArray &passphrase=SecureArray(), PBEAlgorithm pbe=PBEDefault) const
bool | toPEMFile (const QString &fileName, const SecureArray &passphrase=SecureArray(), PBEAlgorithm pbe=PBEDefault) const
RSAPrivateKey | toRSA () const
void | update (const MemoryRegion &a)
Public Member Functions inherited from QCA::PKey
int | bitSize () const
bool | canExport () const
bool | canKeyAgree () const
bool | isDH () const
bool | isDSA () const
bool | isNull () const
bool | isPrivate () const
bool | isPublic () const
bool | isRSA () const
bool | operator!= (const PKey &a) const
PKey & | operator= (const PKey &from)
bool | operator== (const PKey &a) const
| PKey ()
| PKey (const PKey &from)
PrivateKey | toPrivateKey () const
PublicKey | toPublicKey () const
Type | type () const
Public Member Functions inherited from QCA::Algorithm
| Algorithm (const Algorithm &from)
void | change (const QString &type, const QString &provider)
void | change (Provider::Context *c)
Provider::Context * | context ()
const Provider::Context * | context () const
Algorithm & | operator= (const Algorithm &from)
Provider * | provider () const
Provider::Context * | takeContext ()
QString | type () const

## Additional Inherited Members

Public Types inherited from QCA::PKey
enum | Type { RSA , DSA , DH }
Static Public Member Functions inherited from QCA::PrivateKey
static PrivateKey | fromDER (const SecureArray &a, const SecureArray &passphrase=SecureArray(), ConvertResult *result=nullptr, const QString &provider=QString())
static PrivateKey | fromPEM (const QString &s, const SecureArray &passphrase=SecureArray(), ConvertResult *result=nullptr, const QString &provider=QString())
static PrivateKey | fromPEMFile (const QString &fileName, const SecureArray &passphrase=SecureArray(), ConvertResult *result=nullptr, const QString &provider=QString())
static QList< PBEAlgorithm > | supportedPBEAlgorithms (const QString &provider=QString())
Static Public Member Functions inherited from QCA::PKey
static QList< Type > | supportedIOTypes (const QString &provider=QString())
static QList< Type > | supportedTypes (const QString &provider=QString())
Protected Member Functions inherited from QCA::PrivateKey
| PrivateKey (const QString &type, const QString &provider)
Protected Member Functions inherited from QCA::PKey
| PKey (const QString &type, const QString &provider)
void | set (const PKey &k)
DHPrivateKey | toDHPrivateKey () const
DHPublicKey | toDHPublicKey () const
DSAPrivateKey | toDSAPrivateKey () const
DSAPublicKey | toDSAPublicKey () const
RSAPrivateKey | toRSAPrivateKey () const
RSAPublicKey | toRSAPublicKey () const
Protected Member Functions inherited from QCA::Algorithm
| Algorithm ()
| Algorithm (const QString &type, const QString &provider)

## Detailed Description

Diffie-Hellman Private Key.

## Constructor & Destructor Documentation

## DHPrivateKey() [1/2]

QCA::DHPrivateKey::DHPrivateKey | ( |  | ) |

Create an empty Diffie-Hellman private key.

## DHPrivateKey() [2/2]

QCA::DHPrivateKey::DHPrivateKey | ( | const DLGroup & | domain,
|  | const BigInteger & | y,
|  | const BigInteger & | x,
|  | const QString & | provider = QString() )

Create a Diffie-Hellman private key.

Parameters

  domain | the discrete logarithm group to use
  y | the public random value
  x | the private random value
  provider | the provider to use, if a particular provider is required

References domain(), QCA::Algorithm::provider(), x(), and y().

## Member Function Documentation

## domain()

DLGroup QCA::DHPrivateKey::domain | ( |  | ) | const

The discrete logarithm group that is being used.

Referenced by DHPrivateKey().

## y()

BigInteger QCA::DHPrivateKey::y | ( |  | ) | const

The public random value associated with this key.

Referenced by DHPrivateKey().

## x()

BigInteger QCA::DHPrivateKey::x | ( |  | ) | const

The private random value associated with this key.

Referenced by DHPrivateKey().

The documentation for this class was generated from the following file:

- qca_publickey.h